
package com.lantone.qc.kernel.catalogue.clinicalblood;

import com.lantone.qc.kernel.catalogue.QCCatalogue;
import com.lantone.qc.pub.Content;
import com.lantone.qc.pub.model.InputInfo;
import com.lantone.qc.pub.model.OutputInfo;
import com.lantone.qc.pub.model.doc.ClinicalBloodDoc;
import com.lantone.qc.pub.model.doc.InformedConsentDoc;
import com.lantone.qc.pub.util.ListUtil;
import com.lantone.qc.pub.util.StringUtil;
import org.springframework.stereotype.Component;

import java.util.List;
import java.util.Objects;

/**
 * @ClassName : CLI0301
 * @Description : 无输血或使用血液制品知情同意书
 * @Author : cy
 * @Date: 2021-04-18 14:49
 */
@Component
public class CLI0301 extends QCCatalogue {
    public void start(InputInfo inputInfo, OutputInfo outputInfo) {
        status.set("0");
        List<ClinicalBloodDoc> clinicalBloodDocs = inputInfo.getClinicalBloodDocs();
        if (ListUtil.isEmpty(clinicalBloodDocs)) {
            return;
        }
        long cou = inputInfo.getClinicalBloodDocs().stream().map(ClinicalBloodDoc::getStructureMap).filter(Objects::nonNull).count();
        long count = 0L;
        List<InformedConsentDoc> informedConsentDocList = inputInfo.getInformedConsentDoc();

        count = informedConsentDocList.stream().filter(
                informedConsentDoc -> {
                    boolean flag = false;
                    if (informedConsentDoc.getStructureMap() != null
                            && StringUtil.isBlank(informedConsentDoc.getStructureMap().get("标题"))
                            && Content.BLOODRECORDLIST.contains(informedConsentDoc.getStructureMap().get("标题"))) {
                        flag = true;
                    }
                    return flag;
                }
        ).count();

//        if(informedConsentDoc != null){
//            int length = 1;
//            Map<String, String> structureMap = informedConsentDoc.getStructureMap();
//            for (String str : Content.BLOODRECORDLIST) {
//                if(structureMap.containsKey(str)){
//                    String recStr = structureMap.get(str);
//                    if(StringUtils.isNotEmpty(recStr)){
//                        if(recStr.contains("},")){
//                             length = recStr.split("},").length;
//                        }
//                        if(length==1){
//                            count++;
//                        }else{
//                            count = count + length;
//                        }
//
//                    }
//
//                }
//            }
//        }
        if (count == 0L || (cou != count && cou > count)) {
            status.set("-1");
        }
    }
}